<?php

class miboxer extends module
{

   function miboxer()
   {
      $this->name = 'miboxer';
      $this->title = 'Miboxer';
      $this->module_category = '<#LANG_SECTION_DEVICES#>';
      $this->checkInstalled();

      $this->getConfig();
      $this->debmes_debug = ($this->config['MIBOXER_CYCLE_DEBUG'] == 1) ? true : false;
      $this->miboxer_local_interval = (int)($this->config['MIBOXER_LOCAL_INTERVAL'] != '') ? (int)$this->config['MIBOXER_LOCAL_INTERVAL'] : 15;
   }

   function saveParams($data = 0)
   {
      $p = array();
      if (isset($this->id)) {
         $p["id"] = $this->id;
      }
      if (isset($this->view_mode)) {
         $p["view_mode"] = $this->view_mode;
      }
      if (isset($this->edit_mode)) {
         $p["edit_mode"] = $this->edit_mode;
      }
      if (isset($this->data_source)) {
         $p["data_source"] = $this->data_source;
      }
      if (isset($this->tab)) {
         $p["tab"] = $this->tab;
      }
      return parent::saveParams($p);
   }

   function getParams()
   {
      global $id;
      global $mode;
      global $view_mode;
      global $edit_mode;
      global $data_source;
      global $tab;

      if (isset($id)) {
         $this->id = $id;
      }
      if (isset($mode)) {
         $this->mode = $mode;
      }
      if (isset($view_mode)) {
         $this->view_mode = $view_mode;
      }
      if (isset($edit_mode)) {
         $this->edit_mode = $edit_mode;
      }
      if (isset($data_source)) {
         $this->data_source = $data_source;
      }
      if (isset($tab)) {
         $this->tab = $tab;
      }
   }

   function run()
   {
      global $session;

      $out = array();

      if ($this->action == 'admin') {
         $this->admin($out);
      } else {
         $this->usual($out);
      }

      if (isset($this->owner->action)) {
         $out['PARENT_ACTION'] = $this->owner->action;
      }

      if (isset($this->owner->name)) {
         $out['PARENT_NAME'] = $this->owner->name;
      }

      $out['VIEW_MODE'] = $this->view_mode;
      $out['EDIT_MODE'] = $this->edit_mode;
      $out['MODE'] = $this->mode;
      $out['ACTION'] = $this->action;
      $out['DATA_SOURCE'] = $this->data_source;
      $out['TAB'] = $this->tab;
      $this->data = $out;
      $p = new parser(DIR_TEMPLATES . $this->name . "/" . $this->name . ".html", $this->data, $this);
      $this->result = $p->result;
   }

   function admin(&$out)
   {
      //$this->getConfig();

      /* if ((time() - (int)gg('cycle_miboxerRun')) < $this->config['MIBOXER_INTERVAL']+30) {
         $out['CYCLERUN'] = 1;
      } else {
         $out['CYCLERUN'] = 0;
      } */

      $out['MIBOXER_LOCAL_INTERVAL'] = $this->miboxer_local_interval;
      $out['MIBOXER_CYCLE_DEBUG'] = ($this->debmes_debug === true) ? 1 : 0;

      if ($this->view_mode=='update_settings') {

         global $miboxer_local_interval;
         $this->config['MIBOXER_LOCAL_INTERVAL'] = $miboxer_local_interval;

         global $miboxer_cycle_debug;
         $this->config['MIBOXER_CYCLE_DEBUG'] = $miboxer_cycle_debug;

         $this->saveConfig();

         //setGlobal('cycle_miboxerControl', 'restart');
         //setGlobal('cycle_local_miboxerControl', 'restart');

         $this->redirect('?');
      }

      if (isset($this->data_source) && !$_GET['data_source'] && !$_POST['data_source']) {
         $out['SET_DATASOURCE'] = 1;
      }

      if ($this->data_source == 'miboxer_devices' || $this->data_source == '') {
         if ($this->view_mode == '' || $this->view_mode == 'search_miboxer_devices') {
            $this->search_miboxer_devices($out);
         }
         if ($this->view_mode == 'edit_miboxer_devices') {
            $this->edit_miboxer_devices($out, $this->id);
         }
         if ($this->view_mode == 'delete_miboxer_devices') {
            $this->delete_miboxer_devices($this->id);
            $this->redirect("?data_source=miboxer_devices&tab=". $this->tab);
         }
      }

      if (isset($this->data_source) && !$_GET['data_source'] && !$_POST['data_source']) {
         $out['SET_DATASOURCE'] = 1;
      }

      if ($this->data_source == 'miboxer_commands') {
         if ($this->view_mode == '' || $this->view_mode == 'search_miboxer_commands') {
            $this->search_miboxer_commands($out);
         }
         if ($this->view_mode == 'edit_miboxer_commands') {
            $this->edit_miboxer_commands($out, $this->id);
         }
      }
   }

   function usual(&$out)
   {
      if($this->ajax) {
         global $op;
         if($op == 'scan') {
            $this->ScanDevices();
            exit;
         }
      }
      $this->admin($out);
   }

   function search_miboxer_devices(&$out)
   {
      require(DIR_MODULES . $this->name . '/miboxer_search.inc.php');
   }

   function edit_miboxer_devices(&$out, $id)
   {
      require(DIR_MODULES . $this->name . '/miboxer_edit.inc.php');
   }

   function delete_miboxer_devices($id)
   {
       $rec = SQLSelectOne("SELECT * FROM miboxer_devices WHERE ID='$id'");
       SQLExec("DELETE FROM miboxer_commands WHERE DEVICE_ID='" . $rec['ID'] . "'");
       SQLExec("DELETE FROM miboxer_devices WHERE ID='" . $rec['ID'] . "'");
   }

   function search_miboxer_commands(&$out)
   {
      require(DIR_MODULES . $this->name . '/miboxer_commands_search.inc.php');
   }

   function edit_miboxer_commands(&$out, $id)
   {
      require(DIR_MODULES . $this->name . '/miboxer_commands_edit.inc.php');
   }

   function ScanDevices()
   {
      $udp_key = hex2bin(md5('yGAdlopoPVldABfn'));

      $devices = [];

      $socket = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
      @socket_bind($socket, '0.0.0.0', 6667);

      $socket1 = socket_create(AF_INET, SOCK_DGRAM, SOL_UDP);
      @socket_bind($socket, '0.0.0.0', 6666);

      $start_time = time();

      for($i = 1; $i <= 20; $i++) {
         $from = '';
         $port = 0;

         @socket_recvfrom($socket, $buf, 2048, 0, $from, $port);

         $data = substr($buf, 20, -8);
         $result = openssl_decrypt(($data), 'AES-128-ECB', $udp_key, OPENSSL_RAW_DATA);
         $result = json_decode($result, true);

         if(in_array($result['gwId'], $devices) === false && $result['gwId'] !== '') {
            $devices[$result['gwId']] = $result;
            if($result['version'] == '3.3') {
               $version = false;
            } else {
               $version = true;
            }
         }

         @socket_recvfrom($socket1, $buf, 2048, MSG_DONTWAIT, $from, $port);

         $data = substr($buf, 20, -8);
         $result = json_decode($data, true);

         if (in_array($result['gwId'], $devices) === false && $result['gwId'] !== '') {
            $devices[$result['gwId']] = $result;
            if ($result['version'] == '3.3') {
               $version = false;
            } else {
               $version = true;
            }
         }
         if ((time() - $start_time) > 10) break; 
      }

      if(count($devices) > 0) {
         echo '<H4>В локальной сети найдены следующие устройства:</H2>';
         echo '<table>';
         echo '<tr>';
         echo '<th>gwId</td>';
         echo '<th>ip</td>';
         echo '<th>&nbspversion</td>';
         echo '</tr>';
         foreach($devices as $key => $val) {
            echo '<tr>';
            echo "<td>{$val['gwId']}</td>";
            echo "<td>{$val['ip']}</td>";
            echo "<td>&nbsp{$val['version']}</td>";
            echo '</tr>';
         }
         echo '</table>';
      } else {
         echo 'Ничего не найдено.';
      }

      socket_close($socket);
      socket_close($socket1);
   }

   function TuyaLocalMsg($command, $dev_id, $local_key, $local_ip, $data = '')
   {
      $this->WriteLog("TuyaLocalMsg($command, $dev_id, $local_key, $local_ip, $data)");

      $prefix = '000055aa00000000000000';
      $suffix = '000000000000aa55';

      $gw_name = 'gwId';

      if($command == 'STATUS') {
         $hexByte = '0a';
         $json = '{"' . $gw_name . '":"' . $dev_id . '","devId":"' . $dev_id . '"}';
      } else { // SET
         $hexByte = '07';
         $json = '{"' . $gw_name . '":"' . $dev_id . '","devId":"' . $dev_id . '","t":"' . time() . '","dps":' . $data . '}';
      }

      $this->WriteLog("json = $json");

      $json_payload = openssl_encrypt($json, 'AES-128-ECB', $local_key, OPENSSL_RAW_DATA);
      //$this->WriteLog("json_payload = " . bin2hex($json_payload));
      if($command != 'STATUS') {
         $json_payload = hex2bin("332E33000000000000000000000000" . bin2hex($json_payload));
         //$this->WriteLog("json_payload = " . bin2hex($json_payload));
      }

      $postfix_payload = hex2bin(bin2hex($json_payload) . $suffix);
      $postfix_payload_hex_len = dechex(strlen($postfix_payload));

      if(strlen($postfix_payload_hex_len) > 2) {
         $buffer = hex2bin($prefix . $hexByte . '00000' . $postfix_payload_hex_len ) . $postfix_payload;
      } else {
         $buffer = hex2bin($prefix . $hexByte . '000000' . $postfix_payload_hex_len ) . $postfix_payload;
      }

      $buffer = bin2hex($buffer);
      $buffer1 = strtoupper(substr($buffer, 0, -16));

      $hex_crc = dechex(crc32(hex2bin($buffer1)));
      $hex_crc = str_pad($hex_crc, 8, '0', STR_PAD_LEFT);
      $buffer = substr($buffer, 0, -16) . ($hex_crc).substr($buffer, -8);

      $data = $this->TuyaSendReceive(hex2bin($buffer), $local_ip);

      //$this->WriteLog("Response data = " . bin2hex($data));

      $result = substr($data, 20, -8);

      if(mb_substr($result, 0, 1) == '{' ) {
         return $result;
      } else {
         $result = openssl_decrypt($result, 'AES-128-ECB', $local_key, OPENSSL_RAW_DATA);
      }

      //$this->WriteLog("Response data = " . $result);

      return $result;
   }

   function TuyaSendReceive($payload, $local_ip)
   {
      $socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
      socket_set_option($socket, SOL_SOCKET, SO_RCVTIMEO, array('sec' => 1, 'usec' => 0));

      $buf = '';

      if(socket_connect($socket, $local_ip, 6668)) {
          for($i = 0; $i < 3; $i++) {
            $send=socket_send($socket, $payload, strlen($payload), 0);
            if($send != strlen($payload)) {
               $this->WriteLog('Sended ' . $send . ' from ' . strlen($payload) . ' to IP ' . $local_ip);
            }
           $reciv = socket_recv($socket, $buf, 4096, 0);
           if($buf != '') break;
           sleep(1);
         }
      } else {
         $err = socket_last_error($socket); 
         $this->WriteLog(socket_strerror($err) . ' ' . $local_ip);
      }

      socket_close($socket);

      return $buf;
   }

   function processMessage($message, $device_id) {

      // {"dps":{"20":true,"21":"white","22":1000,"23":1000,"24":"0018006e03e8","26":0}}

      $this->WriteLog("Incoming message from ID$device_id: $message");

      $data = json_decode($message, true);

      if (isset($data['dps'])) {
         $dps = $data['dps'];
         foreach($dps as $key => $value) {
            if(is_bool($value)) {
               $value = ($value) ? 1 : 0;
            }
            if($key == '24') {
               $key = 'rgb';
               //$value = bin2hex(base64_decode($value));
            } else if($key == '23') {
               $key = 'ct_all';
               $value = round($value/10);
            } else if($key == '22') {
               $key = 'bright_all';
               $value = round($value/10);
            } else if($key == '21') {
               $key = 'mode';
            } else if($key == '20') {
               $key = 'power_all';
            }
            $this->WriteLog("Incoming command process from ID$device_id: $key = $value");
            //$this->processCommand($device_id, $key, $value);
         }
      }
   }

   function processCommand($device_id, $command, $value, $params = 0, $zone)
   {
      $this->WriteLog("processCommand($device_id, $command, $value, $zone)");

      $cmd_rec = SQLSelectOne("SELECT * FROM miboxer_commands WHERE DEVICE_ID=".(int)$device_id." AND TITLE LIKE '".DBSafe($command)."'");

      if(!$cmd_rec['ID']) {
         $cmd_rec = [];
         $cmd_rec['TITLE'] = $command;
         $cmd_rec['ZONE_ID'] = $zone;
         $cmd_rec['DEVICE_ID'] = $device_id;
         $cmd_rec['VALUE'] = $value;
         $cmd_rec['ID'] = SQLInsert('miboxer_commands', $cmd_rec);
      }

      $old_value = $cmd_rec['VALUE'];

      $cmd_rec['ZONE_ID'] = $zone;
      $cmd_rec['VALUE'] = $value;
      $cmd_rec['UPDATED'] = date('Y-m-d H:i:s');
      SQLUpdate('miboxer_commands', $cmd_rec);

      if(is_null($old_value)) {
         $old_value = '';
      }

      if($old_value == $value) return;

      if($cmd_rec['LINKED_OBJECT'] && $cmd_rec['LINKED_PROPERTY']) {
         setGlobal($cmd_rec['LINKED_OBJECT'] . '.' . $cmd_rec['LINKED_PROPERTY'], $value, array($this->name => '0'));
      }

      if($cmd_rec['LINKED_OBJECT'] && $cmd_rec['LINKED_METHOD']) {
         if(!is_array($params)) {
            $params = array();
         }
         $params['PROPERTY'] = $command;
         $params['VALUE'] = $value;
         $params['OLD_VALUE'] = $old_value;
         $params['NEW_VALUE'] = $value;
         callMethodSafe($cmd_rec['LINKED_OBJECT'] . '.' . $cmd_rec['LINKED_METHOD'], $params);
      }
   }

   function propertySetHandle($object, $property, $value)
   {
      $properties = SQLSelect("SELECT miboxer_commands.*, miboxer_devices.DEV_ID, miboxer_devices.LOCAL_KEY, miboxer_devices.DEV_IP, miboxer_devices.TYPE FROM miboxer_commands LEFT JOIN miboxer_devices ON miboxer_devices.ID=miboxer_commands.DEVICE_ID WHERE miboxer_commands.LINKED_OBJECT LIKE '".DBSafe($object)."' AND miboxer_commands.LINKED_PROPERTY LIKE '".DBSafe($property)."'");

      $total = count($properties);

      if ($total) {
         for($i = 0; $i < $total; $i++) {
            if ($properties[$i]['LOCAL_KEY'] !== '' && $properties[$i]['DEV_IP'] !== '') {
               $property = '';
               $metric = explode('_', $properties[$i]['TITLE']);
               if(isset($metric[0]) && isset($metric[1])) {
                  $property = $metric[0];

                  if(in_array($metric[1], [1,2,3,4,5,6,7,8])) {
                     $zone = $metric[1];
                  } else {
                     $zone = 0;
                  }

                  if($property == 'rgb') {
                     $value = preg_replace('/^#/', '', $value);
                  }

                  $this->WriteLog("Send command to ID{$properties[$i]['DEVICE_ID']}: $property = $value, zone = $zone");

                  $miPacket = $this->getMilightPacket($property, $value, $zone);

                  $this->WriteLog('Raw Milight packet: ' . bin2hex($miPacket));

                  $command = [
                     '101' => base64_encode($miPacket),
                  ];
                  
                  $command = json_encode($command);
                  
                  $this->WriteLog('Milight command: ' . $command);
                  $this->TuyaLocalMsg('SET', $properties[$i]['DEV_ID'], $properties[$i]['LOCAL_KEY'], $properties[$i]['DEV_IP'], $command);
               } else {
                  $property = $properties[$i]['TITLE'];
               }
               SQLExec("UPDATE miboxer_commands SET VALUE='" . DBSafe($value) . "', UPDATED='" . date('Y-m-d H:i:s') . "' WHERE ID=" . $properties[$i]['ID']);
            }
         }
      }
   }

   function getMilightPacket($property, $value, $zone)
   {

      $mi_commands = [
         'set_on'     => [0x06, 0x01, 0x00, 0x00, 0x00],
         'set_off'    => [0x06, 0x02, 0x00, 0x00, 0x00],
         'speed_down' => [0x06, 0x03, 0x00, 0x00, 0x00],
         'speed_up'   => [0x06, 0x04, 0x00, 0x00, 0x00],
         'set_rgb'    => [0x01, 0xFF, 0xFF, 0xFF, 0xFF],
         'set_bright' => [0x02, 0xFF, 0x00, 0x00, 0x00],
         'set_ct'     => [0x03, 0xFF, 0x00, 0x00, 0x00],
         'set_satur'  => [0x04, 0xFF, 0x00, 0x00, 0x00],
         'set_mode'   => [0x05, 0xFF, 0x00, 0x00, 0x00],
      ];

      $mi_packet = [0x41, 0x00, 0x00, 0x09];

      if($property == 'power') {
         if($value == 1) {
            $mi_command = $mi_commands['set_on'];
         } else {
            $mi_command = $mi_commands['set_off'];
         }
      } else if ($property == 'bright') {
         $mi_command = $mi_commands['set_bright'];
         $value = min(100, max(0, $value));
         $mi_command[1] = $value;
      } else if ($property == 'ct') {
         $mi_command = $mi_commands['set_ct'];
         $value = intval((min(100, max(0, $value))) / 100 * 0x26);
         $mi_command[1] = $value;
      } else if ($property == 'rgb') {
         $mi_command = $mi_commands['set_rgb'];
         $value = $this->hex2hsl($value);
         $this->WriteLog("HSL = $value");
         $value = intval(min(360, max(0, $value)) / 360 * 255);
         $mi_command[1] = $value;
         $mi_command[2] = $value;
         $mi_command[3] = $value;
         $mi_command[4] = $value;
      } else if ($property == 'mode') {
         $mi_command = $mi_commands['set_mode'];
         $value = intval(min(9, max(0, $value)));
         $mi_command[1] = $value;
      } else if ($property == 'saturation') {
         $mi_command = $mi_commands['set_satur'];
         $value = min(100, max(0, $value));
         $mi_command[1] = $value;
      } else if ($property == 'speed') {
         if($value == 'up') {
            $mi_command = $mi_commands['speed_up'];
         } else if ($value == 'down') {
            $mi_command = $mi_commands['speed_down'];
         }
      }

      $mi_packet = array_merge($mi_packet, $mi_command);
      $mi_packet[] = dechex($zone);
      $mi_packet[] = 0x02;

      $checksum = 0;
      for ($byteInPacket = 0; $byteInPacket < 11; $byteInPacket++) {
         $checksum = $checksum + $mi_packet[$byteInPacket];
      }
      $mi_packet[] = $checksum & 0xFF;

      $chars = array_map('chr', $mi_packet);

      return join($chars);
   }

   function validate_hex($hex)
   {
      if(preg_match("/^#([0-9a-fA-F]{6})$/", $hex) || preg_match("/^#([0-9a-fA-F]{3})$/", $hex)) {
         $hex = substr($hex, 1);
      }
      if(preg_match("/^([0-9a-fA-F]{6})$/", $hex)) {
         return $hex;
      }
      if(preg_match("/^([0-9a-f]{3})$/", $hex)) {
         return substr($hex, 0, 1) . substr($hex, 0, 1) . substr($hex, 1, 1) . substr($hex, 1, 1) . substr($hex, 2, 1) . substr($hex, 2, 1);
      }
      return '000000';
   }

   function hex2hsl($hex)
   {
      $hex = $this->validate_hex($hex);
      $hex = str_split($hex, 2);
      $r = (hexdec($hex[0])) / 255;
      $g = (hexdec($hex[1])) / 255;
      $b = (hexdec($hex[2])) / 255;
      return $this->rgb2hsl($r, $g, $b);
   }

   function rgb2hsl($r, $g, $b)
   {
      $oldR = $r;
      $oldG = $g;
      $oldB = $b;
      $r /= 255;
      $g /= 255;
      $b /= 255;
      $max = max($r, $g, $b);
      $min = min($r, $g, $b);
      $h;
      $s;
      $l = ($max + $min) / 2;
      $d = $max - $min;
      if($d == 0){
         $h = $s = 0;
      } else {
         $s = $d / (1 - abs(2 * $l - 1));
         switch($max){
             case $r:
                 $h = 60 * fmod((($g - $b) / $d), 6);
                 if ($b > $g) {
                     $h += 360;
                 }
                 break;
             case $g:
                 $h = 60 * (($b - $r) / $d + 2);
                 break;
             case $b:
                 $h = 60 * (($r - $g) / $d + 4);
                 break;
         }
      }
      return round($h, 2);
   }

   function WriteLog($msg)
   {
      if ($this->debmes_debug) {
         DebMes($msg, $this->name);
      }
   }

   function install($data = '')
   {
      parent::install();
   }

   function uninstall()
   {
      SQLExec('DROP TABLE IF EXISTS miboxer_devices');
      SQLExec('DROP TABLE IF EXISTS miboxer_commands');
      parent::uninstall();
   }

   function dbInstall($data = '')
   {
      $data = <<<EOD
 miboxer_devices: ID int(10) unsigned NOT NULL auto_increment
 miboxer_devices: TITLE varchar(100) NOT NULL DEFAULT ''
 miboxer_devices: TYPE varchar(100) NOT NULL DEFAULT ''
 miboxer_devices: DEV_ID varchar(255) NOT NULL DEFAULT ''
 miboxer_devices: LOCAL_KEY varchar(255) NOT NULL DEFAULT ''
 miboxer_devices: DEV_IP varchar(255) NOT NULL DEFAULT ''
 miboxer_devices: UPDATED datetime
 miboxer_devices: MAC varchar(30) DEFAULT ''
 
 
 miboxer_commands: ID int(10) unsigned NOT NULL auto_increment
 miboxer_commands: TITLE varchar(100) NOT NULL DEFAULT ''
 miboxer_commands: ZONE_ID int(10) NOT NULL DEFAULT '1'
 miboxer_commands: VALUE varchar(255) NOT NULL DEFAULT ''
 miboxer_commands: DEVICE_ID int(10) NOT NULL DEFAULT '0'
 miboxer_commands: LINKED_OBJECT varchar(100) NOT NULL DEFAULT ''
 miboxer_commands: LINKED_PROPERTY varchar(100) NOT NULL DEFAULT ''
 miboxer_commands: LINKED_METHOD varchar(100) NOT NULL DEFAULT ''
 miboxer_commands: UPDATED datetime

EOD;

      parent::dbInstall($data);
   }
}
